<template>
    <f7-page 
        name="notification" 
        @page:beforein="onPageBeforeIn"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Notifikasi">
            <f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Pemberitahuan</f7-nav-title>
		</f7-navbar>       
        <f7-list media-list no-hairlines v-if="!notificationLoading && notifications.length > 0">
            <f7-list-item
                v-for="(item, index) in notifications"
                :key="index"
                :title="item.title"
                :after="hoursAgo(item.created)"
            >
                <img :src="require('../assets/icon-notif.png')" width="48" slot="media">
                <div slot="text" v-html="item.body">{{ item.body }}</div>
            </f7-list-item>
        </f7-list>
        <f7-block v-else-if="!notificationLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="notifications_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-list media-list no-hairlines v-else-if="notificationLoading">
            <f7-list-item
                v-for="n in 4"
                :key="n"
                :class="`skeleton-text skeleton-effect-blink`"
                title="Full Name"
                after="20 Juni 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum."
            >
                <f7-skeleton-block style="width: 48px; height: 48px;" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { hoursAgo } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Notification',
	data(){
		return{
            allowInfinite: true,
            showPreloader: true,
            notificationLoading: true
        };
	},
	computed: {
		...mapGetters('auth', [
            'user',
            'notifications',
            'notificationPagination'
        ]),
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        $$('div[data-name="notification"]').on('click', 'a.geo', function(){
            let href = $$(this).data('href');
            location.href = href;
        });
    },
    methods: {
        hoursAgo,
        convertAmpersand(text){
            return text.replace(/&amp;/g, '&');
        },
        getNotifications(page, loadmore){
			const self = this;
            const app = self.$f7;
            
			self.$store.dispatch('auth/getNotifications', {
                page: page,
                perpage: 25,
                loadmore: loadmore,
                only:'title,created,body'
            }).then(()=>{
                setTimeout(()=>{
                    self.notificationLoading = false;
                    self.showPreloader = self.notificationPagination.has_next;
                }, 100);
            });
        },
        onPageBeforeIn(){
            const self = this;
            self.getNotifications(1, false);
        },
        onPageRefresh(e, done){
            const self = this;

            self.notificationLoading = true;

            self.getNotifications(1, false);
            done();
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.notificationPagination.has_next){
                    self.getNotifications(self.notificationPagination.page + 1, true);
                    self.allowInfinite = true; 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
    }
}
</script>
